{$APPTYPE CONSOLE}

label X;

var
  A, B: array of array [0..3] of Integer;
  D: array of array [0..20, 0..20, 0..20] of record p0, p1, p2: Byte end;
  f: TextFile;

  function chk(i: integer): boolean;
  begin
    Result := 
      (n0 >= A[i, 0]) and (n1 >= A[i, 1]) and (n2 >= A[i, 2]) and
      (N - n0 - n1 - n2 >= A[i, 3]);
  end;

begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N, T);
  SetLength(A, T + 1);
  SetLength(B, T + 1);
  SetLength(D, T + 1);
  for i := 1 to T do
    Read(f, A[i, 0], A[i, 1], A[i, 2], A[i, 3]);
  CloseFile(f);

  for i := 1 to T do
    FillChar(D[i, 0, 0, 0], SizeOf(D[i]), $FF);
  for n0 := 0 to N do
    for n1 := 0 to N do
      for n2 := 0 to N do
        if chk(1) then D[1, n0, n1, n2].p0 := 0;
  
  for i := 2 to T do begin
    for n0 := 0 to N do
      for n1 := 0 to N do
        for n2 := 0 to N do begin
          if not chk(i) then continue;
        end;
  end;
  
  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, Q);
  if Q = 0 then Halt(0);
  for n0 := 0 to N do
    for n1 := 0 to N do
      for n2 := 0 to N do
        if D[Q, n0, n1, n2].p0 <> $FF then goto X;
  X:;
  
  for i := Q downto 1 do begin
    B[i, 0] := n0;
    B[i, 1] := n1;
    B[i, 2] := n2;
    B[i, 3] := N - n0 - n1 - n2;
    with D[Q, n0, n1, n2] do begin
      n0 := p0; n1 := p1; n2 := p2;
    end;  
  end;
  for i := 1 to Q do
    Writeln(f, B[i, 0], B[i, 1], B[i, 2], B[i, 3]);
  CloseFile(f);
end.
